var validatorRequestArray= {};
var dictionary =  {};
var taskArray = {};
var hiddenDiv = document.createElement("DIV");
var maxTimer = 8 * 60;  // maximum for request timeout in seconds
var defTimer = 20;  //default timeout
  //special global variable
var execScriptsParam = null;

function zeroOrText(s){
  if (s == "\0")
            return "";
  else
    return s;
};

function htmlDecode(s) {
  return s.replace(/&gt;/g,">").replace(/&lt;/g, "<").replace(/&quot;/g, "\"").replace(/&amp;/g, "&");
};
function htmlEncode(s) {
  return s.replace(/&/g, "&amp;").replace(/>/g,"&gt;").replace(/</g, "&lt;").replace(/\"/g, "&quot;");
};

function setCookie (name, value, expires, path, domain, secure) {
  if (!expires) {
    expires = new Date();
    expires.setTime(expires.getTime() + (1000 * 86400 * 365));
    expires = expires.toGMTString();
  }
      document.cookie = name + "=" + escape(value) +
        "; expires=" + expires  +
        ((path) ? "; path=" + path : "; path=/") +
        ((domain) ? "; domain=" + domain : "") +
        ((secure) ? "; secure" : "");
};

function getCookie(name) {
	var cookie = " " + document.cookie;
	var search = " " + name + "=";
	var setStr = null;
	var offset = 0;
	var end = 0;
	if (cookie.length > 0) {
		offset = cookie.indexOf(search);
		if (offset != -1) {
			offset += search.length;
			end = cookie.indexOf(";", offset)
			if (end == -1) {
				end = cookie.length;
			}
			setStr = unescape(cookie.substring(offset, end));
		}
	}
	return(setStr);
};

var  CreateRequest = function(){
  var Request = false;

  if (window.XMLHttpRequest)
    {
	    //Gecko- Safari, Konqueror
	    Request = new XMLHttpRequest();
    }
  else if (window.ActiveXObject)
    {
	    //Internet explorer
	    try
        {
          Request = new ActiveXObject("Microsoft.XMLHTTP");
        }
	    catch (CatchException)
        {
          Request = new ActiveXObject("Msxml2.XMLHTTP");
        }
    }

  if (!Request)
    {
	    alert("Can`t create XMLHttpRequest");
    }

  return Request;
};

function trim(str) {
  return ("" + str).replace( /^\s*(\S*)\s*$/ , "$1" );  
};

function getAttribute(obj, name){
  var attr=obj.attributes;
  var i; 
  if(attr) { 
    for ( i = attr.length; i > 0; i--) {
      if (attr[i-1].nodeName == name)
	      return attr[i-1].nodeValue;
    }
  }
  return "";
};

function enquote(str) {
  return str;
  return str.replace("\\", "\\\\").replace("\"", "\\\"");
}

function buildPath(eThis, type) {
	if (eThis && eThis.parentNode && (eThis.className != "root") ) {
    var parent = findParentByTag(eThis, "LI", 20);
    if(type == ",") {
      if(parent && (parent.className != "root"))
        return  buildPath(parent, type) + "," + enquote(getAttribute(eThis, "name")) + "";
      else
        return  "" + enquote(getAttribute(eThis, "name")) + "";
    } else {
      if(parent)
        return  buildPath(parent, type) + "." + getAttribute(eThis, "name");
      else
        return  getAttribute(eThis, "name") ;
    } 
  }
	else
		return ""
      }

function getText(eThis) {
  var spans = eThis.getElementsByTagName("span");
  var texts;
  var text = "";
  for (var i=0;i<spans.length;i++) {
    if (spans[i].className == "hiddentext") {
      texts = spans[i].getElementsByTagName("textarea");
      if (texts.length>0 && texts[0].className == "hiddentext") {
        //alert('n:'+i+"/"+spans.length+":"+texts[i].value);
        text = text + texts[0].value.substring(1, texts[0].value.length -1);
      }
      spans[i].innerHTML = "";
    }
  }
  return text;
}

function execScripts(eThis, param) {
  var scripts = eThis.getElementsByTagName("span");
  var texts;
  for (var i=0;i<scripts.length;i++) {
    if (scripts[i].className == "hiddenscript") {
      texts = scripts[i].getElementsByTagName("textarea");
      if (texts.length>0 && texts[0].className == "hiddentext") {
        window.execScriptsParam = param;
        eval(texts[0].value.substring(1, texts[0].value.length -1));
      }
      scripts[i].innerHTML = "";
    }
  }
  window.execScriptsParam = null; 
}

function loadMenu(eThis) {
	SendDataTree( eThis , "load" , true)
    }

function getLiClasses(top) {
	var liList=top.getElementsByTagName("li");
	var li;
	var i;
	var data = "";
	for ( i = 0; i< liList.length; i++) { 
		li = liList.item(i);
		if( li && (getAttribute(li, 'name') != "") 
        && (getAttribute(li, 'name').charAt(0) == '.') 
        && ( findParentByTagClass(li.firstChild, 'li', "disabled") == null )
        && ( findParentByTagClass(li.firstChild, 'li', "hidden_empty") == null )
        //&& ( findChildByTag(li, 'ul') != null )
        ) {
			data = data + encodeURIComponent("class." + buildPath(li, ",")) + "=" + encodeURIComponent(getAttribute( li, "class")) +"&";
		} 
	}
	return data;
};


function SendRequestAsync(r_method, r_path, r_args, r_handler, timer) {
  var request = CreateRequest();
  var timeOut;
  if (typeof(timer) == "undefined") {
    timer = defTimer;
  }
  if (r_args.search(/&timeout=[0-9]+&/) > 0) {
    r_args = r_args.replace(/&timeout=[0-9]+&/, "&timeout=" + timer + "&");
  }
  else {
    r_args=r_args + "&timeout=" + timer + "&";
  }

  if (!request)
    {
	    return null;
    }
  var requestErrFunction = function(text, timer) {
    if(confirm(text)) {
      request.abort();
      if (timer > maxTimer) {
        timer = maxTimer;
      }
      SendRequestAsync(r_method, r_path, r_args, r_handler, timer);
    };
  };

  timeOut = setTimeout(function(){
      requestErrFunction("Request timeout("+timer+"sec), the server is busy or not available, try again with biger timeout?", timer * 2);
    }, timer * 1000);
  

  request.onreadystatechange = function() {
    if (request.readyState == 4) {
      clearTimeout(timeOut);
      if((request.status == 200) || (request.status == 204))
        r_handler(request);
      else if (request.status == 0)
        { //timeout, abort or other  do nothing
        }
      else if (request.status == 404)
        requestErrFunction("Error 404: Requested URL is not found. Try again?", timer);
      else if (request.status == 403)
        requestErrFunction("Error 403: Access denied. Try again?", timer);
      else
        requestErrFunction("Error " + request.status +". Try again?", timer);
    }
  }

  //r_args += "&rnd=" + Math.random();

  if (r_method.toLowerCase() == "get" && r_args.length > 0)
    r_path += "?" + r_args;

  request.open(r_method, r_path, true);

  if (r_method.toLowerCase() == "post")
    {
	    request.setRequestHeader("Content-Type","application/x-www-form-urlencoded; charset=utf-8");
	    request.send(r_args);
    }
  else
    {
	    request.send(null);
    }
	return request;
}

function findParentByTag(_parent, tag, maxLevel) {
  _parent = _parent.parentNode
  if( !tag || !tag.toUpperCase) {
    alert("Some error:"+tag);
  }
  if((maxLevel <= 0) || (_parent == null)) {
    return null;
  } else if( tag && _parent.nodeName.toUpperCase() == tag.toUpperCase()) {
    return _parent;
  } else if(_parent.parentNode) {
    return findParentByTag(_parent, tag, maxLevel-1)
	    } else {
    return null;
  }
  return null;
}

function findParentByTagClass(_parent, tag, _class, maxLevel) {
  if((maxLevel <= 0) || (_parent == null) || (_parent.parentNode == null) ) {
    return null;
  }
  _parent = _parent.parentNode;
  if(_parent.nodeName.toUpperCase() == tag.toUpperCase() &&
            (_parent.className.toUpperCase() == _class.toUpperCase()) ) {
    return _parent;
  } else {
    return findParentByTagClass(_parent, tag, _class, maxLevel-1);
  }
  return null;
}


function _findChildByTagClass(_parent, tag, _class, maxLevel, stopTag, stopClass) {
  if((maxLevel <= 0) 
     || (_parent == null) 
     ) {
    return {"node":null, "level":0};
  } else if(_parent.childNodes) {
    var childs = _parent.childNodes;
    var max_ret = null;
    var max_level = 0;
    var i = 0;
    for ( i = 0 ; i < childs.length; i++) {

      if(((stopTag && (childs.item(i).nodeName.toUpperCase() == stopTag.toUpperCase()))
          && (!stopClass || (stopClass && childs.item(i).className && (childs.item(i).className.toUpperCase() == stopClass.toUpperCase()))))) {
        // do nthing just skip it
      } else if((childs.item(i).nodeName.toUpperCase() == tag.toUpperCase()) && 
                (!_class || (childs.item(i).className.toUpperCase() == _class.toUpperCase()))) {
        return {"node":childs.item(i), "level":maxLevel};
      } else {
        res = _findChildByTagClass(childs.item(i), tag, _class, maxLevel - 1, stopTag, stopClass);
        if( res.node && (res.level > max_level) ) {
          max_level = res.level;
          max_ret = res.node;
          return { "node":max_ret, "level":max_level}
        }
      }
    }
  }
  return {"node":null,"level":0};
}

function findChildByTag(_parent, tag, maxLevel, stopTag, stopClass) {
  res= _findChildByTagClass(_parent, tag, null, maxLevel, stopTag, stopClass);
  return res.node;
}

function findChildByTagClass(_parent, tag, _class, maxLevel, stopTag, stopClass) {
  res = _findChildByTagClass(_parent, tag, _class, maxLevel, stopTag, stopClass);
  return res.node;
}

function UnHide( eThis , expand){
  var li = findParentByTag(eThis, 'LI', 6);
  var ret;
  if(li) {
    if( (expand != undefined && expand>0 ) || (li.className == "cl" && ! (expand != undefined && expand==0 )) ){
      ret =  li.className != "ex";
      li.className = "ex";
      var pleasewait = findChildByTagClass(li, "input", "pleasewait", 10, "li");
      if(pleasewait) {
        loadDir(li);
      } else {
        var runfirst = findChildByTagClass(li, "input", "runfirst", 10, "li");
        if(runfirst) {
          var dir = findParentByTagClass(runfirst, "div", "dir",4);
          dir.innerHTML = getHelp("runFirst");
        }
      }
    }else{
      ret =  li.className != "cl";
      li.className = "cl";
    }
  }
  return ret;
}


function loadDictionary() {
  var data = AUTH + "&command=loadDictionary&";

  if(validatorRequestArray["_loadDictionary"]) {
    validatorRequestArray["_loadDictionary"].abort();
  }
  var Handler = function(Request)
    {
      hiddenDiv.innerHTML = zeroOrText(Request.responseText);
      execScripts(hiddenDiv);
    }
  validatorRequestArray["_loadDictionary"] = SendRequestAsync("post", window.location/*PAGENAME*/, data, Handler, 60);
  return 0;
}
loadDictionary();

function Enable( eThis ){	
  var li = findParentByTag(eThis, "LI");
  var td =  findChildByTagClass(li, "td","value", 10);
  var stype = findChildByTagClass(td, "INPUT", "stype",  11, "UL");
  var span = findParentByTag(eThis, 'SPAN', 6); 
  var value;
  if(span) {
    if( span.className == "enabled" ){
      //     value = "nil";
      value = "nil";
    }else{
      value =   "\"" + getAttribute(li, "name") + "\"";
      //value = "{}";
    }

    var path = buildPath(findParentByTag(li.parentNode, "LI", 10), ","); 
    // var path = buildPath(li, ","); 
    var data = AUTH + "&command=setValue&path={"+encodeURIComponent(path)+"}&value="+encodeURIComponent(value)+"&";

    if(validatorRequestArray[path]) {
      validatorRequestArray[path].abort();
    }

    var Handler = function(Request)
      {
        hiddenDiv.innerHTML = zeroOrText(Request.responseText);
          var newLi = findChildByTag(hiddenDiv,"LI", 2);
          if (newLi) {
            hiddenDiv.removeChild(newLi);
            li.parentNode.replaceChild(newLi, li);
          } else {
            li.innerHTML =  li.innerHTML +  zeroOrText(Request.responseText);
          }
          execScripts(li);
      }
    validatorRequestArray[path] = SendRequestAsync("post", window.location/*PAGENAME*/, data, Handler);
  }
}

function paramName(elem) { 
  var table = findChildByTagClass(elem, "table", "node",  10, "ul");
  var td = findChildByTagClass(table, "td", "param",  10, "ul");
  var value = findChildByTagClass(td, "INPUT", "value",  10, "ul");
  return parseInt(value.value);
}

function paramStype(elem) { 
  var table = findChildByTagClass(elem, "table", "node",  10, "ul");
  var td = findChildByTagClass(table, "td", "param",  10, "ul");
  var value = findChildByTagClass(td, "INPUT", "stype",  10, "ul");
  return value;
}

function findSibling(elem, tag) {
  if (!elem || !tag) return null;
  var next = elem;
  next = next.nextSibling;
  if(next) {
    if (next.nodeName && (next.nodeName.toUpperCase() == tag.toUpperCase()))
      return next
      else
        return findSibling(next, tag)
          } 
  else {
    return null;
  }
}

function findPrevSibling(elem, tag) {
  if (!elem || !tag) return null;
  var next = elem;
  next = next.previousSibling;
  if(next) {
    if (next.nodeName && (next.nodeName.toUpperCase() == tag.toUpperCase()))
      return next
      else
        return findPrevSibling(next, tag)
          } 
  else {
    return null;
  }
}

function findNextElem( elem) {
  var tag = elem.nodeName;
  var stype = paramStype(elem);
  var next = elem;
  do {	
    next = next.nextSibling;
    nstype = paramStype(next);
  } while ( next && ((next.nodeName != tag) 
                     || ((stype) && (nstype) && (stype.value != nstype.value)) 
                     || ((stype) && (!nstype)) 
                     || ((!stype) && (nstype)))
            );
  return next;
}

function emptyHandler() {
}



function StopUpdate( ) { 
  if(top.nsg_timer != 0) {
    clearTimeout(top.nsg_timer);
    top.nsg_timer  = 0;
  }
}

function FormatTime(t) {
  if (t<10) {
    return "0"+t;
  }
  return t;
}

function startEdit(eThis){
  var spanContainer = findParentByTagClass(eThis, "span", "reload", 4);
  if(spanContainer) {
    return;
  }
  spanContainer = findParentByTagClass(eThis, "span", "normal", 4);
  if(! spanContainer) {
    spanContainer = findParentByTagClass(eThis, "span", "disabled", 4);
  }
  if(spanContainer) {
    var input = findChildByTagClass(spanContainer, "input", "inline", 4);
    if(! input )  {
      input = findChildByTagClass(spanContainer,"select", "inline", 4);
    }
    spanContainer.className = "edit";
    if(input) {
      input.focus();
    }
  }
}

function findParamName(eThis) {
  var li = eThis;
  if (li.nodeName.toLowerCase() != "li")
    li = findParentByTag(eThis, "li", 10);
  if(! li)
    return null;
  var a = findChildByTagClass(li, "a", "name", 7);
  return a;
}

function stopEdit(eThis){
  var spanContainer = findParentByTagClass(eThis, "span", "edit", 4);
  if(spanContainer) {
    var lastvalue = findChildByTagClass(spanContainer, "input", "lastvalue",3);
    var tmp = eThis.onblur;
    eThis.onblur = null;
    findParamName(eThis).focus();
    if(lastvalue.disabled)
      spanContainer.className = "disabled";
    else
      spanContainer.className = "normal";
    eThis.onblur = tmp;
  }
}

function inLineOnClick(eThis){
  var text = eThis.innerHTML;
  stype="_NAME";
  eThis.onclick = null;
  eThis.innerHTML="<input type=text value=\""+text+"\" onkeypress=\"return inLineOnKeyPress(this, event)\" onblur=\"return inLineOnBlur(this)\" onchange=\"return inLineOnChange(this)\">";
  eThis.getElementsByTagName("input").item(0).focus();
}

function deleteItem(eThis, prompt) {
	var li = findParentByTag(eThis, "LI");
  var td =  findChildByTagClass(li, "td","value", 10);
  var stype = findChildByTagClass(td, "INPUT", "stype",  11, "UL");

 	var path = buildPath(li, ",");
  abortReq(path);

  var confirm=window.confirm(prompt);

  if (confirm ) {
    var data = AUTH + "&command=removeKey&path={"+encodeURIComponent(path)+"}&";
    if(li){ 
      li = findParentByTag(li, "LI");
      var Handler = function(Request)
        {
          hiddenDiv.innerHTML =  zeroOrText(Request.responseText);
            execScripts(hiddenDiv);
            updateDep(li);
        }
      uniqReq(path, SendRequestAsync("post", window.location/*PAGENAME*/, data, Handler));
    }
  }
}



function newItem(eThis, prompt, cmd) {
	var li = findParentByTag(eThis, "LI");
  var td =  findChildByTagClass(li, "td","value", 10);
  var stype = findChildByTagClass(td, "INPUT", "stype",  11, "UL");
 	var path = buildPath(li, ",");
  abortReq(path);
  var newName=window.prompt(prompt,"");
  if (newName != null) {
    var data = AUTH + "&command=" + cmd +"&path={"+encodeURIComponent(path)+"}&value="+encodeURIComponent(newName)+"&";

    if(li){
      var Handler = function(Request)
        {
          hiddenDiv.innerHTML =  zeroOrText(Request.responseText);
            execScripts(hiddenDiv);
            updateDep(li);
        }
      uniqReq(path, SendRequestAsync("post", window.location/*PAGENAME*/, data, Handler));
    }
  }
}

function applyCfg(eThis) {
	var li = findParentByTag(eThis, "LI");
 	var path = buildPath(li, ",");
  abortReq(path);
  var data = AUTH + "&command=applyConf&path={"+encodeURIComponent(path)+"}&";

  if(li){
    var Handler = function(Request)
      {
        hiddenDiv.innerHTML =  zeroOrText(Request.responseText);
          execScripts(hiddenDiv);
      }
    uniqReq(path, SendRequestAsync("post", window.location/*PAGENAME*/, data, Handler));
  }
}

function saveCfg(eThis) {
	var li = findParentByTag(eThis, "LI");
 	var path = buildPath(li, ",");
  abortReq(path);
  var data = AUTH + "&command=saveConf&path={"+encodeURIComponent(path)+"}&";

  if(li){
    var Handler = function(Request)
      {
        hiddenDiv.innerHTML =  zeroOrText(Request.responseText);
          execScripts(hiddenDiv);
      }
    uniqReq(path, SendRequestAsync("post", window.location/*PAGENAME*/, data, Handler));
  }
}

function setLocale(eThis) {
  var data = AUTH + "&command=setLocale&locale=" + eThis.value + "&";
  window.LOCALE = eThis.value;
  abortReq("locale");
  var Handler = function(Request)
    {
      hiddenDiv.innerHTML =  zeroOrText(Request.responseText);
      execScripts(hiddenDiv);
    }
  uniqReq("locale", SendRequestAsync("post", window.location/*PAGENAME*/, data, Handler));
}

function getManual(eThis) {
	var li = findParentByTag(eThis, "LI");
 	var path = buildPath(li, ",");
  abortReq(path);
  var data = AUTH + "&command=getManual&path={"+encodeURIComponent(path)+"}&";

  if(li){
    var Handler = function(Request)
      {
        hiddenDiv.innerHTML =  zeroOrText(Request.responseText);
          execScripts(hiddenDiv);
      }
    uniqReq(path, SendRequestAsync("post", window.location/*PAGENAME*/, data, Handler));
  }
}

function Edit(eThis) {
  var li = findParentByTag(eThis, "LI");
 	var path = buildPath(li, ",");
  abortReq(path);
  var data = AUTH + "&command=edit&mode=text&path={"+encodeURIComponent(path)+"}&";

  if(li){
    var dir = findChildByTagClass(li, "div", "dir", 3);
    if(dir) {
      var Handler = function(Request)
        {
          dir.innerHTML =  zeroOrText(Request.responseText);
          execScripts(dir);
        }
      uniqReq(path, SendRequestAsync("post", window.location/*PAGENAME*/, data, Handler, 60));
    }
  }
}

function validateCfg(eThis) {
  var li = findParentByTag(eThis, "LI");
 	var path = buildPath(li, ",");
  abortReq(path);
  var text = findChildByTagClass(li, "textarea", "edit", 10);
  var data = AUTH + "&command=validate&path={"+encodeURIComponent(path)+"}&value="+encodeURIComponent(text.value) + "&";

  if(li){
    var dir = findChildByTagClass(li, "div", "dir", 3);
    if(dir) {
      var Handler = function(Request)
        {
          hiddenDiv.innerHTML =  zeroOrText(Request.responseText);
          execScripts(hiddenDiv);
        }
      uniqReq(path, SendRequestAsync("post", window.location/*PAGENAME*/, data, Handler));
    }
  }
}

function clearDir(eThis) {
  var li = findParentByTag(eThis, "LI");
 	var path = buildPath(li, ",");
  var confirm=window.confirm(getHelp("webBtnClearDirConfirm"));

  if (confirm ) {
    var data = AUTH + "&command=paste&path={"+encodeURIComponent(path)+"}&value=&";
    abortReq(path);
    if(li){
      var dir = findChildByTagClass(li, "div", "dir", 3);
      if(dir) {
        var Handler = function(Request)
          {
            hiddenDiv.innerHTML =  zeroOrText(Request.responseText);
            execScripts( hiddenDiv, dir);
          }
        uniqReq(path, SendRequestAsync("post", window.location/*PAGENAME*/, data, Handler));
      }
    }
  }
}

function saveEditCfg(eThis) {
  var li = findParentByTag(eThis, "LI");
 	var path = buildPath(li, ",");
  abortReq(path);
  var text = findChildByTagClass(li, "TEXTAREA", "edit", 10);
  var data = AUTH + "&command=paste&path={"+encodeURIComponent(path)+"}&value="+encodeURIComponent(text.value) + "&";

  if(li){
    var dir = findChildByTagClass(li, "div", "dir", 3);
    if(dir) {
      var Handler = function(Request)
        {
          hiddenDiv.innerHTML =  zeroOrText(Request.responseText);
          execScripts( hiddenDiv, dir);
        }
      uniqReq(path, SendRequestAsync("post", window.location/*PAGENAME*/, data, Handler));
    }
  }
}


function setValue(eThis) {
	var li = findParentByTag(eThis, "LI");
  //after removing li has now parent, but may cose some events..
  if(! li.parentNode)
    return;

  var td =  findChildByTagClass(li, "td","value", 10);
  var stype = findChildByTagClass(td, "INPUT", "stype",  11, "UL");
	var name = findChildByTagClass(td, "INPUT", "value",  11, "UL"); 
  if(name && name.value == "") {
    setNil(eThis);
    return;
  }

 	var path = buildPath(li, ",");
  abortReq(path);

	var data = AUTH + "&command=setValue&path={"+encodeURIComponent(path)+"}&value="+encodeURIComponent(name.value)+"&";

  if(li){
    var Handler = function(Request)
      {
        hiddenDiv.innerHTML =  zeroOrText(Request.responseText);
          var newLi = findChildByTag(hiddenDiv,"LI", 2);
          if (newLi) {
            eThis.onblur = null;
            li.parentNode.replaceChild(newLi, li);
          }
          execScripts(hiddenDiv);
          updateDep(newLi)
      }
  	uniqReq(path, SendRequestAsync("post", window.location/*PAGENAME*/, data, Handler));
  }
}

function setNil(eThis) {
	var li = findParentByTag(eThis, "LI");
 	var path = buildPath(li, ",");
  abortReq(path);
	var data = AUTH + "&command=setValue&path={"+encodeURIComponent(path)+"}&";

  if(li){
    var Handler = function(Request)
      {
        hiddenDiv.innerHTML =  zeroOrText(Request.responseText);
          var newLi = findChildByTag(hiddenDiv,"LI", 2);
          if (newLi) {
            hiddenDiv.removeChild(newLi);
            li.parentNode.replaceChild(newLi, li);
            li = newLi;
          } else {
            li.innerHTML =  li.innerHTML +  zeroOrText(Request.responseText);
          }
          execScripts(li);
          updateDep(li);
      }
    uniqReq(path, SendRequestAsync("post", window.location/*PAGENAME*/, data, Handler));
  }
}


function inLineOnBlur(eThis, className){ 
  var spanContainer = findParentByTagClass(eThis, "span", "edit", 4); 
  if(spanContainer){
    var value = findChildByTagClass(spanContainer, "input", "value", 4);
    var input = findChildByTagClass(spanContainer, "input", "inline", 4);
    var help = "header=[webEditHelp] ";
    if(! input )  {
      input = findChildByTagClass(spanContainer,"select", "inline", 4);
    }
    value.value = input.value;
    if(typeof value.nsgTitle == 'undefined')
      value.title = help;
    else
      value.nsgTitle = help;
    if (!className) className = "reload";
    spanContainer.className = className;
  }
}

function executeTask(eThis, mode) {
	var li = findParentByTag(eThis, "LI");
	li.className = "ex";
	var dir = findChildByTagClass(li, "div", "dir", 3);
  var td =  findChildByTagClass(li, "td","value", 10);
  var stype = findChildByTagClass(td, "INPUT", "stype",  11, "UL");
	var name = findChildByTagClass(td, "INPUT", "value",  11, "UL"); 
  var data;
	var path = buildPath(li, ",");
	var ctrlPath = buildPath(li, "."); // for web tty!!!
  var Handler;
  abortReq(path);

  if ((mode== "interactive") && (eThis.className == "bstop")) { 
    eThis.className='bexec';
    if( taskArray[".dynamic." + ctrlPath]){
      taskArray[".dynamic." + ctrlPath].kbd_buffer =  taskArray[".dynamic." + ctrlPath].kbd_buffer + "%%%";
    }
    return;
  }
  else {
    data = AUTH + "&command=executeTask&path={"+encodeURIComponent(path)+"}&value="+encodeURIComponent((name ? name.value : ""))+"&";
    if(dir) {
      var scroll = window.scrollTop;
      dir.innerHTML = "<img  class=\"loading\" src=\"/loading.gif\">" +getHelp("pleaseWait");
      /*handler start*/
      Handler = function(Request) {
        hiddenDiv.innerHTML =  zeroOrText(Request.responseText);
        var response = getText(hiddenDiv);
        //alert("handler:"+response);
        if (mode == "interactive" && (response.length==0)) {
          eThis.className = 'bstop';
          dir.innerHTML =
            "Use ^A..Z, ^[, ^], ^_ as control key and ^^ as '^'<br>" +
            "<div id='.dynamic." + ctrlPath + "'>" +
            "</div>";
          if( taskArray[".dynamic." + ctrlPath]){
            taskArray[".dynamic." + ctrlPath].cleanup();
          }
          taskArray[".dynamic." + ctrlPath] = init_webtty_object(".dynamic." + ctrlPath, function(){
              eThis.className='bexec';
            });
        } else {
          if(response.length > 0) {
            var rows = 1+response.split("\n").length;
            dir.innerHTML = "<textarea wrap=off class=\"readonly\" readonly cols=\"80\" rows=\""+
            (rows > 2 ? (rows < 25 ? rows : 25) : 2)+
            "\" "+
            "ondblclick=\"UnHide(this);\""+
            ">" + response + "</textarea>";
            var text_area = findChildByTag(dir,"textarea",4);
            text_area.scrollTop = text_area.scrollHeight;
          } else {
            dir.innerHTML = "";
          }
        }
        execScripts(hiddenDiv);
        hiddenDiv.innerHTML = "";
        window.scrollTop = scroll;
        updateDep(li);
      }
      /*handler end*/
      //alert("startHandler");
      uniqReq(path, SendRequestAsync("post", window.location/*PAGENAME*/, data, Handler));
    }
  }
};

function getLiClasses(top) {
	var liList=top.getElementsByTagName("li");
	var li;
	var i;
	var data = "";
	for ( i = 0; i< liList.length; i++) {
		li = liList.item(i);
		if( li && (getAttribute(li, 'name') != "")
        && li.className == "ex") {
      data = data + encodeURIComponent("LC" + buildPath(li,".")) + "=&";
		} 
	}
	return data;
};

function loadDir(li, clearCache) {
  if (li.nodeName.toUpperCase() != "LI")
    li = findParentByTag(li, "LI",10);

	var dir = findChildByTagClass(li, "div", "dir", 3);
  if(dir) {
    var scroll = window.scrollTop;
    var Handler = function(Request)
      {
        dir.innerHTML = zeroOrText( Request.responseText);
        execScripts(dir);
        window.scrollTop = scroll;
      }

    var path = buildPath(li, ",");
    var data = AUTH + "&command=getConf&path={"+encodeURIComponent(path)+"}&"+ getLiClasses(li);
    if ((typeof(clearCache ) != "undefined") & clearCache)
      data = data + "&clearcache=&";
    dir.innerHTML = "<img class=\"loading\" src=\"/loading.gif\">" + getHelp("pleaseWait");
    SendRequestAsync("post", window.location/*PAGENAME*/, data, Handler, 60);
  }
}

function updateDep(li) {
  var dep = findChildByTagClass(li, "input","dep", 10);
  if (dep) {
    for(dep = dep.value;
        dep > 0 && li && li.className != "root";
        dep = dep - 1) {
      li = findParentByTag(li, "LI");
    };
    if (li)
      loadDir(li);
  }
}

function uniqReq(name, request){
    if(validatorRequestArray[name]) {
      validatorRequestArray[name].abort();
    }
    validatorRequestArray[name] = request;
}

function abortReq(name){
  uniqReq(name, null);
}

function getHTML(li) {
  if (li.nodeName.toUpperCase() != "LI")
    li = findParentByTag(li, "LI",10);
  var path = buildPath(li, ",");
  var data = AUTH + "&command=getHTML&subcmd=start&path={"+encodeURIComponent(path)+"}&";

  hiddenDiv.innerHTML =
    "<form name=\"nsghiddenform\" id=\"nsghiddenform\" method=\"post\" target=\"_blank\" >" +
    "<input type=\"hidden\" name=\"command\" value=\"getHTML\">"+
    "<input type=\"hidden\" name=\"subcmd\" value=\"start\">"+
    "<input type=\"hidden\" name=\"path\" value=\"{"+htmlEncode(path)+"}\">"+
    "<input type=\"hidden\" name=\"login\" value=\""+htmlEncode(LOGIN)+"\">"+
    "<input type=\"hidden\" name=\"pass\" value=\""+htmlEncode(PASS)+"\">"+
    "<input type=\"submit\">"+
    "</form>";

  var form =  findChildByTag(hiddenDiv,"form",10);
  form = hiddenDiv.removeChild(form);
  var body = findChildByTag(document,"body", 10);
  body.appendChild(form);
  form.submit();
  body.removeChild(form);
}


function logOut(force) {
	var Handler = function(Request)
    {
      hiddenDiv.innerHTML =  zeroOrText(Request.responseText);
        execScripts(hiddenDiv);
    }

	var data = AUTH + "&command=logOut";
  if(force)
    data = data + "&force=true";
	SendRequestAsync("post", window.location/*PAGENAME*/, data, Handler);
}

function valueKeyDown(e,eThis) {
  var key = 0;
  if (!e) var e = window.event;
  if (e.keyCode) key = e.keyCode;
  else if (e.which) key = e.which;
  if (key==13) //Enter 
    {
      startEdit(eThis);
      return false;
    }
}

function inLineKeyDown(e,eThis) {
  var key = 0;
  if (!e) var e = window.event;

  if (e.keyCode) key = e.keyCode;
  else if (e.which) key = e.which;

  if (key==13) //Enter
    {
      eThis.onblur();
      return false;
    }
  else if (key==27) //Escape
    {
      stopEdit(eThis);
      return false;
    }
}

//key down on param name
function paramKeyDown(e,eThis) {
  var key = 0;
  var li = findParentByTag(eThis, "LI");
  var td =  findChildByTagClass(li, "td","param", 10);
  var stype = findChildByTagClass(td, "INPUT", "stype",  11, "UL");
  if (!e) var e = window.event;

  if (e.keyCode) key = e.keyCode;
  else if (e.which) key = e.which;

  if (key==13) //Enter
    {
      if (stype && stype.value=="dir")
        UnHide(eThis);
      else { 
        td =  findChildByTagClass(li, "td","value", 10);
        var input =   findChildByTagClass(td, "input","value", 10);
        startEdit(input);
      }
      return false;
    }
  else if (key==37) // left
    {
      if ((stype && stype.value=="dir") && (li.className == "ex"))
        UnHide(eThis, 0); //collapse
      else { // go to parent
        li =  findParentByTag(li, "LI");
        if (li) {
          td =  findChildByTagClass(li, "td","param", 10);
          if (td) {
            var a =  findChildByTagClass(td, "a","name", 10);
            if(a)
              a.focus();
          }
        }
      }
      return false;
    }
  else if (key==39) // right
    {
      if ((stype && stype.value=="dir") && (! UnHide(eThis, 1))) {// expand 
        var dir =  findChildByTagClass(li, "div","dir", 10);
        if (dir) {
          var a =  findChildByTagClass(dir, "a","name", 10);
          if (a)
            a.focus();
        }
      }
      return false;
    }
  
  if (key==38) // top
    {
      var prevLi = findPrevSibling( li, "LI");
      if (prevLi) {
        var  ul = findChildByTag(prevLi, "UL", 10);
        for(;prevLi && prevLi.className == "ex" && findChildByTag(ul, "LI", 3);) {
          prevLi = ul.lastChild;
          if (prevLi && (!prevLi.nodeName || (prevLi.nodeName.toUpperCase() != "LI")))
            prevLi = findPrevSibling(prevLi, "LI");
          ul = findChildByTag(prevLi, "UL", 10);
        }
      } else {
        prevLi =  findParentByTag(li, "LI");
      }
      if (prevLi && prevLi.nodeName && prevLi.nodeName.toUpperCase()== "LI") {
        td =  findChildByTagClass(prevLi, "td","param", 10);
        if (td) {
          var a =  findChildByTagClass(td, "a","name", 10);
          if(a)
            a.focus();
        }
      }
      return false;
    }
  else if (key==40) //down
    {
      var  nextLi =  findChildByTag(findChildByTag(li, "UL", 10), "LI", 10);
      if (li.className == "expanded" &&  nextLi){
      } else {
        nextLi = li;
        for(;nextLi && !findSibling(nextLi, "LI");) {
          nextLi = findParentByTag( nextLi, "LI");
        }
        nextLi = findSibling(nextLi, "LI");
      }
      if(nextLi) { 
        td =  findChildByTagClass(nextLi, "td","param", 10);
        if (td) {
          var a =  findChildByTagClass(td, "a","name", 10);
            if(a)
              a.focus();
        }
      }
      return false;
    }
}

function msgBox(msg, btn1, btn2, btn3, btn4, btn5) {
  var dlgBody = "<html><title>NSG WEB Configuration manager</title><body><center>"+msg+"<br/><input type=button value="+btn1+" onclick=\"window.returnValue=1; window.close();\" >";
  if(btn2) {
    dlgBody = dlgBody + "&nbsp;&nbsp;<input type=button value="+btn2+" onclick=\"window.returnValue=2; window.close();\" >";
  }
  if(btn3) {
    dlgBody = dlgBody + "&nbsp;&nbsp;<input type=button value="+btn3+" onclick=\"window.returnValue=3; window.close();\" >";
  }
  if(btn4) {
    dlgBody = dlgBody + "&nbsp;&nbsp;<input type=button value="+btn4+" onclick=\"window.returnValue=4; window.close();\" >";
  }
  if(btn5) {
    dlgBody = dlgBody + "&nbsp;&nbsp;<input type=button value="+btn5+" onclick=\"window.returnValue=5; window.close();\" >";
  }
  
  dlgBody = dlgBody + "</center></body><script  type=\"text/javascript\" >alert(\"KUUU!\")</script></html>";
  return showModalDialog("javascript:document.write(window.dialogArguments);", dlgBody, "center:yes; dialogHeight:150px; dialogWidth:400px; status:no; resizible:no");
}

function textBox(msg, text, btn1, btn2, btn3) {
  var dlgBody = "<html><title>NSG WEB Configuration manager</title><body><center>"+msg+"<br/><textarea cols=\"80\" rows=\"25\" >"+text+"</textarea><br/><input type=button value="+btn1+" onclick=\"window.returnValue=1; window.close();\" >";
  if(btn2) {
    dlgBody = dlgBody + "&nbsp;&nbsp;<input type=button value="+btn2+" onclick=\"window.returnValue=2; window.close();\" >";
  }
  if(btn3) {
    dlgBody = dlgBody + "&nbsp;&nbsp;<input type=button value="+btn3+" onclick=\"window.returnValue=3; window.close();\" >";
  }
  
  dlgBody = dlgBody + "</center></body></html>";
  return showModalDialog("javascript:document.write(window.dialogArguments);", dlgBody, "center:yes; dialogHeight:600px; dialogWidth:700px; status:no;");
}

